; Program za mnozenje 16-bitnih brojeva metodom zbrajanja, v1
; - Uvjet zadatka: multiplikator je broj bez predznaka

	AREA mult_16_v1, CODE, READWRITE
		
ADDR EQU 0x8100		; adresa na kojoj se nalaze podatci
		
	ENTRY

	MOV R4, #ADDR   		; postavlja R4 adresu podataka
	LDRH R5, [R4], #2	; multiplikator se ucitava u R5
	LDRSH R6, [R4], #2	; multiplikand se ucitava u R6
									; (predznak sacuvan)
	MOV R7, #0				; cisti se registar za spremanje
									; rezultata (R7)

PETLJA	
	CMP R5, #0				; usporedba multiplikatora i nule
	BEQ kraj					; ako je nula, mnozenje je gotovo
	ADD R7, R7, R6			; pribroji multiplikand rezultatu. 
	SUB R5, R5, #1			; umanji multiplikator za jedan
	B PETLJA	 

kraj
	STR R7, [R4]			; spremi rezultat

	MOV R0, #0x18			; angel_SWIreason_ReportException
    	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
    	SWI 0x123456      	; ARM semihosting SWI
		
	END

	
