; Program za 8-bitno zbrajanje, verzija 2

	AREA add_8_v2, CODE, READWRITE

ADDR EQU 0x8100				; adresa na kojoj se nalaze podatci

	ENTRY
	
	MOV R4, #ADDR   		; postavlja registar R4 na 8100(16)

	LDRSB R5, [R4], #1	; ucitava se prvi operand,
				; oktet je prosiren cuvajuci predznak,
				; (ako se zeli bez predznaka treba koristiti LDRB),
				; korisiti se post-indexiranje!!
	LDRSB R6, [R4], #1	; ucitava se drugi operand

	ADD R5, R5, R6			; zbrajanje (ovo je uvijek 32-bitno)

	STRB R5, [R4]			; spremanje rezultata

kraj
	MOV R0, #0x18			; angel_SWIreason_ReportException
	LDR R1, =0x20026		; ADP_Stopped_ApplicationExit
	SWI 0x123456			; ARM semihosting SWI
	
	END	

