;Program za 8-bitno zbrajanje dva broja bez predznaka, ver.1
	AREA add_8u_v1, CODE, READWRITE 	;definicije asembleru
	ENTRY					; oznaka pocetka programskog odsjecka

	LDRB R0, A			; prvi operand se ucitava u R0 (za 
								; signed se koristi LDRSB)
	LDRB R1, B			; drugi operand se ucitava u R1 (za
								; signed se koristi LDRSB)
	ADDS R4, R0, R1	; izvodi se zbrajanje i postavljaju se
								; zastavice (S)
	STRB R4, REZ		; rezultat se sprema u memoriju
	
kraj								; povratak iz simulacije
	MOV R0, #0x18		; angel_SWIreason_ReportException
	LDR R1, =0x20026	; ADP_Stopped_ApplicationExit
	SWI 0x123456		; ARM semihosting SWI
	
A	DCB 100					; prvi operand (oktet)
B	DCB 0x20				; drugi operand (oktet)
REZ	SPACE 1					; rezultat (oktet)

	END	

