; Program za 64-bitno zbrajanje, verzija 2
	AREA add_64_v2, CODE, READWRITE
	
ADDR EQU 0x8100			; adresa na kojoj se nalaze podatci
	ENTRY
	
	MOV R4, #ADDR   		; postavlja registar R4 na 8100(16)
	LDR R5, [R4], #4 		; ucitavanje operanda A nizi dio (AL)
									; koristi se postindeksiranje!!!
	LDR R6, [R4], #4		; ucitavanje operanda A visi dio (AH)
	LDR R7, [R4], #4		; ucitavanje operanda B nizi dio (BL)
	LDR R8, [R4], #4		; ucitavanje operanda B visi dio (BH)

	ADDS R5, R5, R7		; zbrajanje niza 32 bita 
									; s postavljanjem zastavica
	ADC R6, R6, R8			; zbrajanje visa 32 bita i 
									; prijenosa iz prethodne operacije
	STR R5, [R4], #4		; spremanje rezultata nizi dio (RESL)
	STR R6, [R4]			; spremanje rezultata visi dio (RESH)

kraj	
	MOV R0, #0x18			; angel_SWIreason_ReportException
	LDR R1, =0x20026		; ADP_Stopped_ApplicationExit
	SWI 0x123456			; ARM semihosting SWI
	END

