	`ORG 0
	B	GLAVNI

	`ORG 18				; adresa za obradu iznimke IRQ
	MOV R12, R14	; sacuvaj R14
	EOR R7, R7, #1	; mijenjaj znak 0<->1
	MOV R0, R7		; 
	BL LCDWR			; salje se na LCD
	MOV R0, #0A		; znak 0xA, ispis znaka na zaslonu
	BL LCDWR			; salje se na LCD
	MOV R0, #0D		; znak 0xD, brise se interni registar
	BL LCDWR			; salje se na LCD

	MOV R4, #8		
	STR R4, [R3, #8]		; cisti se RTCINTR bit

	MOV R4, #0
	STR R4, [R3, #0C]	; napuni ponovno brojac
	MOV R4, #5
	STR R4, [R3, #4]		;napuni ponovo RTCMR
	MOV R14, R12			;vrati povratnu adresu (R14)
	SUBS PC, R14, #4		;povratak iz obrade iznimke
	 
GLAVNI	
	MOV	R7, #0x30			;postavi znak za ispis u '0'
	MOV	R1, #1<8
	LDR	R2, [R1], #4	;u R2 je adresa GPIO
	LDR	R3, [R1]			;u R3 je adresa RTC

	MOV	R4, #5
	STR	R4, [R3, #4]	; napuni RTCMR
	MOV	R4, #1
	STR	R4, [R3, #10]	; omoguci prekid (RTCCR)

	MRS R0, CPSR 			; procitaj CPSR u R0
	BIC R0, R0, #0x80	; na mjestu I bita se stavlja nula
	MSR CPSR_c, R0 		; i to se ponovo zapisuje u CPSR
									; da bi se omogucila obrada IRQ


PETLJA	
	B PETLJA

	SWI	123456

;potprogram za ispis jednog znaka s GPIO na LCD
LCDWR	
	AND	R0, R0, #7F		;postavi bit 7 u nulu
	STRB R0, [R2, #4]
	ORR R0, R0, #80		;postavi bit 7 u jedan
	STRB R0, [R2, #4]
	AND R0, R0, #7F		;postavi bit 7 u nulu
	STRB R0, [R2, #4]
	MOV PC, LR				;povratak
	
	`ORG	100
DATA1	DW	0FFFFFF00			; adresa sklopa GPIO
DATA2	DW	0FFFFFE00 		; adresa sklopa RTC

